import numpy as np
import amodal as am
import graficas as gr
import csv

'''PARAMETROS'''
RUTA = '/home/jesus/1tfg/codigo/Programa_Pycharm/FlaskFolder/static/upload_xlsx/VigaMaderaA-3-01.xlsx'
# RUTA = '/home/jesus/1tfg/codigo/Programa_Pycharm/FlaskFolder/static/upload_xlsx/PruebaViga200213-1.xlsx'
NFFT = np.array([1,2,3,4]) # factor por el que se multiplica nperseg
NPERSEG = np.array([2048, 4096, 8192, 16384])
RANGO = np.array([[1,2],[3,7],[11,14],[19,24],[29,35]])

senal = am.Tiempo()
senal.lectura(RUTA)

# Bucle para calcular todos los parametros
for nfft in NFFT:
    for nperseg in NPERSEG:
        # Se calcula la frf
        am.preset.nperseg_frf = nperseg
        am.preset.nfft_frf = nfft*nperseg
        frf = senal.get_frf()
        frf.integrar()
        frf.integrar()
        # Se calculan los modos de resonancia
        modos = am.Modal(frf,rango_unico=RANGO)
        modos.peak_picking()
        modos.promedio()
        # Se guardan los datos en tablas csv, como texto.
        with open('frec-{}-{}'.format(nperseg,nfft) ,'w') as file:
            writer = csv.writer(file,delimiter='\t')
            for acelerometro in modos.frec_resonancia:
                acelerometro = np.round(acelerometro,decimals=5)
                writer.writerow(acelerometro)
            writer.writerow(np.round(modos.frec_resonancia_media,decimals=5))
        with open('amor-{}-{}'.format(nperseg,nfft) ,'w') as file:
            writer = csv.writer(file,delimiter='\t')
            for acelerometro in modos.amortiguamiento:
                acelerometro = np.round(acelerometro,decimals=5)
                writer.writerow(acelerometro)
            writer.writerow(np.round(modos.amortiguamiento_medio,decimals=5))
