import numpy as np
import amodal as am
import graficas as gr

'''PARAMETROS'''
RUTA = '/home/jesus/1tfg/codigo/Programa_Pycharm/FlaskFolder/static/upload_xlsx/VigaMaderaA-3-01.xlsx'
VENTANA = 3 # Ventana en Hz
AVANCE =  0.25  # Avance en tanto por uno

# Calculamos la frf y creamos la clase modos
senal = am.Tiempo()
senal.lectura(RUTA)
frf = senal.get_frf()
frf.integrar()
rango = np.array([[1,2]])
modos = am.Modal(frf,rango_unico= rango)

# Definimos la ventana, avance, y el numero final de elementos
ventana = int(frf.frecrate * VENTANA)
avance = int(ventana * AVANCE)
tamano = int((frf.axis_1 + avance-ventana-1)//avance)

# Se definen dos vectores vacios para guardar los datos
# Frecs guarda aquellos datos que no tienen errores en ninguna senal
frecs = np.zeros(0)
# Frecs1 guarda aquellos datos que tienen un error en alguna senal
frecs1 = np.zeros(0)

for i in range(tamano):
    # Calculamos la ventana y los modos en cada iterecion
    frec = np.array([[i*avance/modos.frf.frecrate,(i*avance+ventana)/modos.frf.frecrate]])
    modos.adaptar_rango(frec)
    modos.circle_fit()
    # Se detectan cuantos valores '0' hay en los modos
    error_amortiguamiento = np.count_nonzero(modos.amortiguamiento == 0)
    if error_amortiguamiento==0:
        modos.promedio()
        frecs = np.append(frecs, modos.frec_resonancia_media[0])
    if error_amortiguamiento<=2:
        modos.promedio()
        frecs1 = np.append(frecs1, modos.frec_resonancia_media[0])

print('Las frecuencias de resonancia sin errores en los amortiguamientos son:\n', frecs)
print('Las frecuencias de resonancia con menos de dos errores en el amortiguamiento son:\n', frecs1)

# Se combinan las frecuencias que estan muy cerca,
# se halla la media de los valores.
resonancias = np.zeros([0])
cache = np.zeros([0])
for i in range(len(frecs1)):
    if i == 0:
        resonancias = np.append(resonancias,frecs1[i])
        continue

    if abs(frecs1[i]- frecs1[i-1])  < 1:

        cache = np.append(cache,frecs1[i])
        resonancias[-1] = np.mean(cache)

    else:
        resonancias = np.append(resonancias,frecs1[i])
        cache = np.zeros([0])

print('Las frecuencias de resonancia son:',resonancias)

